/* Lesson 17.9 Demo - Use a Set-Based Solution */

-->>>>>>Use SET STATISTICS statements to provide execution information<<<<<<--
SET STATISTICS IO ON;
SET STATISTICS TIME ON;
SET STATISTICS XML ON;

-->>>>>>Create a temporary table to implement query: Summing numbers from 1 to 10<<<<<<--
-->>>>>>First implement row-based cursor solution<<<<<<----------------------------------
DECLARE @Test TABLE ( Data INT )

INSERT @Test
( Data )
	VALUES (1),(2),(3),(4),(5),(6),(7),(8),(9),(10);

SELECT Data
	FROM @Test

---------------------------------------------
DECLARE curSum CURSOR FOR
SELECT Data
FROM @Test

DECLARE @s INT ,
@Total INT = 0

OPEN curSum

FETCH NEXT
FROM curSum
INTO @s

WHILE @@FETCH_STATUS = 0 
BEGIN
SET @Total += @s
FETCH NEXT
FROM curSum
INTO @s
END

CLOSE curSum
DEALLOCATE curSum

SELECT @Total AS 'SUM Using Cursor Solution';

--------------------------------------------------------------
-->>>>>>Implement set-based  solution<<<<<<-------------------

SELECT SUM ( Data ) AS 'SUM Using Set Solution'
FROM @Test

SET STATISTICS IO OFF;
SET STATISTICS TIME OFF;
SET STATISTICS XML OFF;